 
/* ga-cfp.h */

#define MAX_CLASSES      20   /* maximum no. of classes */
#define MAX_FEATURES    200   /* maximum no. of features */
#define MAX_DATA       1000   /* maximum no. of instances */
#define MAX_NAME         60   /* maximum length of a name */
#define MAX_LINE       2000   /* maximum length of a line */
#define MAX_CHROMOSOMES 500   /* maximum number of chromosomes */
#define MAX_GENES       200   /* maximum number of genes */

#define INFINITE  (float)2.0E+10

#define KNOWN '*'
#define UNKNOWN '?'
#define UNDETERMINED 0
#define NULL  0
#define TRUE  1
#define FALSE 0

typedef int FEATURE;
typedef int CLASS;

typedef float VALUE;

typedef struct {
  VALUE value[MAX_FEATURES];
  char status[MAX_FEATURES];
  CLASS class;			/* 0 for undetermined */
} INSTANCE;

struct segment {
  float repr;                   /* number of instance in it */
  float lower, upper;           /* RangeNodes of the feature  */
  int class;	                /* class value of the R    */
  struct segment *left, *right;
};
typedef struct segment SEGMENT;

void read_data(), read_settings();             /* io.c */
void load_intervals(), save_intervals();       /* io.c */
void show_intervals();                         /* io.c */
void initialize_partitions();                  /* partitions.c */
int free_partitions();                         /* partitions.c */
SEGMENT *search();                             /* partitions.c */
float ga_learn_parameters ();                  /* ga.c */
void set_ga_defaults();                        /* ga.c */
float fitness();                               /* ga-cfp.c */
